## metview 4.8.0

=== CMakeLists.txt ===
############################################################################################
# cmake options:
#
#       -DCMAKE_BUILD_TYPE=Debug|RelWithDebInfo|Release|Production
#
#       -DCMAKE_MODULE_PATH=/path/to/ecbuild/cmake
#
#       -DCMAKE_C_COMPILER=gcc
#       -DCMAKE_C_COMPILER=g++
#
#       -DCMAKE_PREFIX_PATH=/path/to/jasper:/path/to/any/package/out/of/place
#       -DBUILD_SHARED_LIBS=OFF
#
#  Metview-specific:
#  -DMETVIEW_SITE=ecmwf | other
#  -DMETVIEW_SCRIPT=name-of-generated-startup-script
#  -DMARS_HOME=/path/to/MARS/home  (requires WITH_MARS=ON)
#  -DMAGICS_PATH=/path/to/magics   (requires WITH_PLOTTING=ON)
#  -DEXTRA_TITLE=extra-title-string
#  -DLOG_DIR=/path/to/dir/for/module/log/files
#  -DODB1_USE_SCRIPT_PATH=/path/to/odb1/use/script

cmake_minimum_required( VERSION 2.8.11 FATAL_ERROR )

project( metview C CXX Fortran)


# All executables and scripts apart from the startup script should go into MV_BIN_DIR.
# Users can override by setting METVIEW_INSTALL_EXE_BIN_DIR.
# It should be relative to the root of the install directory.
if(DEFINED METVIEW_INSTALL_EXE_BIN_DIR)
    set(MV_BIN_DIR ${METVIEW_INSTALL_EXE_BIN_DIR})
else()
    set(MV_BIN_DIR bin/metview_bin)
endif()


set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")
set(CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE OFF)

set(METVIEW_INSTALL_BIN_DIR "${MV_BIN_DIR}" CACHE PATH "Metview installation directory for executable files")

include( ecbuild_system NO_POLICY_SCOPE )


ecbuild_requires_macro_version( 1.9 )

ecbuild_enable_fortran( REQUIRED )


###############################################################################
# some options of this project

option( ENABLE_UI            "enable the user interface"                          ON )
option( ENABLE_MOTIF         "enable the classic Motif-based user interface"      OFF )
option( ENABLE_PLOTTING      "enable the plotting module"                         ON )
option( ENABLE_OPERA_RADAR   "enable OPERA radar filter module (requires proj4)"  AUTO )
option( ENABLE_MARS          "enable MARS access"                                 OFF )
option( ENABLE_ODB           "enable ODB"                                         OFF )
option( ENABLE_MARS_ODB      "enable ODB in MARS"                                 OFF )
option( ENABLE_USAGE_LOG     "enable usage logging (only at ECMWF)"               OFF )
option( ENABLE_QT_DEBUG      "enable Qt debugging messages"                       OFF )
option( ENABLE_QT5           "enable Qt5"                                         OFF )
option( ENABLE_INPE          "enable INPE modules"                                ON )
option( ENABLE_URL_DOWNLOAD  "enable downloading of files from URLs"              ON )
option( ENABLE_WEATHER_ROOM  "enable Weather Room plot export (only at ECMWF)"    OFF )
option( ENABLE_NETWORK_PROXY "enable network proxy settings for WMS"              OFF )
option( ENABLE_EXPERIMENTAL  "enable experimental modules"                        OFF )
option( ENABLE_CONTRIB       "enable externally contributed modules"              OFF )
 
###############################################################################


# ensure we can add non-existent dependencies - required for generating icon files
if( ${CMAKE_VERSION} VERSION_GREATER "2.9.9" )
    cmake_policy(SET CMP0046 OLD)
endif()



# if we don't explicitly state that we're at ECMWF, then assume we're not, and use the generic config
if(NOT METVIEW_SITE STREQUAL ecmwf)
    set( SITE_WMO_CODE "255")    # DO WE NEED AN OPTION TO ALLOW INSTALLERS TO SPECIFY THIS?
    set( MV_ENVIRON    "common")
    set( AT_ECMWF "FALSE" )
    ecbuild_info("Building outside ECMWF")
else()
    set( SITE_WMO_CODE "098")
    set( MV_ENVIRON    "ecm_lnx64")
    set( AT_ECMWF "TRUE" )
    add_definitions( -DECMWF )
    ecbuild_info("Building inside ECMWF")
endif()


if(DEFINED EXTRA_CONFIG_PATH)
    ecbuild_info("Will search ${EXTRA_CONFIG_PATH} for additional config files")
endif()



# default startup script name
if(NOT DEFINED METVIEW_SCRIPT )
    set( METVIEW_SCRIPT "metview" )
endif()

set(FULL_STARTUP_SCRIPT_PATH ${CMAKE_BINARY_DIR}/bin/${METVIEW_SCRIPT})

# ensure we don't build shared libraries
set(BUILD_SHARED_LIBS OFF)


# Weather Room plot export (ECMWF only)
if(ENABLE_WEATHER_ROOM)
    if(AT_ECMWF)
        ecbuild_add_extra_search_paths( boost ) # Weather Room export needs Boost
        find_package( Boost 1.49.0 )            # Weather Room export needs Boost
        set(MV_WEATHER_ROOM_BUILT true)
    else()
        ecbuild_error("ENABLE_WEATHER_ROOM only available when building at ECMWF")
    endif()
else()
    set(MV_WEATHER_ROOM_BUILT false)
endif()


if(ENABLE_INPE)
    set(METVIEW_INPE true)
endif()


# --------------------------------
# look for MARS client source code
# --------------------------------

if(MARS_SOURCE_PATH)
    # if the user specified a path, then only look there
    set(MARS_SOURCE_PATHS ${MARS_SOURCE_PATH}/src)
else()
    # otherwise look in some default locations
    set(MARS_SOURCE_PATHS ${CMAKE_SOURCE_DIR}/src/libMars         # embedded in source
                          ${CMAKE_SOURCE_DIR}/src/libMarsClient   # embedded in source
                          ${CMAKE_SOURCE_DIR}/mars-client/src     # bundle
                          ${CMAKE_SOURCE_DIR}/mars_client/src     # bundle
                          ${CMAKE_SOURCE_DIR}/../client/src       # in external dir
                          ${CMAKE_SOURCE_DIR}/../mars-client/src  # in external dir
                          ${CMAKE_SOURCE_DIR}/../mars_client/src) # in external dir
endif()

ecbuild_debug("Looking for MARS source in ${MARS_SOURCE_PATHS}")
find_path( MARS_SOURCE request.c
           HINTS ${MARS_SOURCE_PATHS}
           PATH_SUFFIXES src
           DOC "Path to MARS client source code"
           NO_DEFAULT_PATH )

if (MARS_SOURCE)
    ecbuild_info("Found MARS source at ${MARS_SOURCE}")
else()
    ecbuild_critical("MARS source is required, but was not found in  ${MARS_SOURCE_PATHS}")
endif()


# ensure the MARS client source is included in the tarball (if necessary)
if(NOT ${MARS_SOURCE} STREQUAL ${CMAKE_SOURCE_DIR}/src/libMars)
    list( APPEND CPACK_SOURCE_INSTALLED_DIRECTORIES
            "${MARS_SOURCE}" "src/libMarsClient")
endif()



# look for curl because it is needed for the Mars Web API client
find_package(CURL)

# local MARS access
if(ENABLE_MARS)
    set( MARS_ACCESS MARS_local )
    set( METVIEW_MARS 1 )
    if(DEFINED MARS_LOCAL_HOME)
        ecbuild_info("MARS_LOCAL_HOME=${MARS_LOCAL_HOME}")
        if(NOT EXISTS ${MARS_LOCAL_HOME})
            ecbuild_critical("MARS_LOCAL_HOME (${MARS_LOCAL_HOME}) does not exist")
        else()
            set(MARS_HOME ${MARS_LOCAL_HOME})
        endif()
    else()
        ecbuild_critical("If setting local MARS access, -DMARS_LOCAL_HOME=/path/to/mars/home must be provided.")
    endif()

    # FDB
    if(AT_ECMWF)
        ecbuild_use_package( PROJECT FDB REQUIRED )
    else()
        ecbuild_use_package( PROJECT FDB )
    endif()

    ecbuild_debug("FDB: ${FDB_LIBRARIES}")

    if( NOT FDB_FOUND )
        ecbuild_info("NO FDB")
    endif()


    if(ENABLE_MARS_ODB)
        set(ENABLE_ODB 1)
        set(METVIEW_MARS_ODB 1)
    endif()

    #find_library( FDB  REQUIRED )
    #ecbuild_debug("FDB: ${FDB_LIBRARIES}" )

else()
    if(${CURL_FOUND})
        set( MARS_ACCESS MARS_webapi )
    else()
        set( MARS_ACCESS MARS_none )
        add_definitions(-DNOCURL)
        ecbuild_warn("Could not find the Curl library - disabling Web API Mars")
    endif()
endif()


# Network access (download via URLs)
if(ENABLE_URL_DOWNLOAD)
    if(NOT CURL_FOUND)
        ecbuild_critical("URL_DOWNLOAD was enabled, but the 'curl' development package was not found.")
    endif()
endif()




###############################################################################
# local project requirements

# ecbuild_use_package( PROJECT eckit VERSION 0.3 REQUIRED )

ecbuild_add_option( FEATURE ECCODES DESCRIPTION "" DEFAULT ON )

if( HAVE_ECCODES )
  ecbuild_use_package( PROJECT eccodes VERSION 0.14 REQUIRED )
  set( GRIB_API_INCLUDE_DIRS ${ECCODES_INCLUDE_DIRS} )
  set( GRIB_API_LIBRARIES    ${ECCODES_LIBRARIES} )
  set( GRIB_API_DEFINITIONS  ${ECCODES_DEFINITIONS} )
  set( grib_api_BASE_DIR     ${eccodes_BASE_DIR} )
  add_definitions(-DGRIB_HANDLING_PACKAGE=ecCodes)
else()
  ecbuild_use_package( PROJECT grib_api VERSION 1.13.0 REQUIRED )
  add_definitions(-DGRIB_HANDLING_PACKAGE=GRIB_API)
endif()


if(ENABLE_ODB)
    ecbuild_use_package( PROJECT odb_api  VERSION 0.10.1 ) # requires at least this version
    if( ODB_API_FOUND )

        set( METVIEW_ODB_API_LIBRARIES Odb )
        # does this version use eckit?
        list(FIND ODB_API_LIBRARIES eckit ODB_ECKIT_INDEX)
   

        if ((NOT ODB_ECKIT_INDEX EQUAL -1) OR (DEFINED ODB_ECKIT))  # is an eckit version
            if (DEFINED SEPARATE_ECKIT)
                ecbuild_use_package( PROJECT eckit VERSION 0.6 REQUIRED )
            endif()
            add_definitions(-DODB_ECKIT)
        endif()

        set(METVIEW_ODB 1)

        if(ODB_API_PATH)
            set(ODB_API_LIB_DIR ${ODB_API_PATH}/lib)
            set(ODB_API_BIN_DIR ${ODB_API_PATH}/bin)
        endif()

        add_definitions(-DMETVIEW_ODB_NEW -DMETVIEW_ODB)
        set(METVIEW_ODB_API_INCLUDE_DIRS ${ODB_API_INCLUDE_DIRS}
                                         ${ODB_API_INCLUDE_DIRS}/..
                                         ${ODB_API_INCLUDE_DIRS}/../eclib
                                         ${ODB_API_INCLUDE_DIRS}/../eclib/eclib
                                         ${ODB_API_INCLUDE_DIRS}/odblib
                                         ${ECKIT_INCLUDE_DIRS}) 
    else()
        if(ENABLE_MARS_ODB)
            ecbuild_critical("ENABLE_ODB was set, but ODB not found")
            set(ENABLE_MARS_ODB 0)
            set(METVIEW_MARS_ODB 0)
        endif()
    endif()
    ###list( APPEND METVIEW_TPLS odb_api )


    # ODB-1

    ecbuild_use_package( PROJECT ODB )
    
    if(ODB_FOUND)
        if(EXISTS ${ODB_PATH}/bin)
            if(EXISTS ${ODB_PATH}/bin/odbsql)
                add_definitions(-DMETVIEW_ODB_OLD)
                set(ENABLE_ODB1 "ON")

                if(ODB1_USE_SCRIPT) # was an ODB-1 use script name passed?
                    set(ODB1_LOAD_ENV "MV_ODB1_USE_SCRIPT=${ODB1_USE_SCRIPT}")
                endif()

                if(ODB1_MODULE) # was an ODB-1 module name passed?
                    set(ODB1_LOAD_ENV "MV_ODB1_MODULE=${ODB1_MODULE}")
                endif()

                if(ODB1_VERSION) # was an ODB-1 module name passed?
                    set(MV_ODB1_VERSION ${ODB1_VERSION})
                else()
                    set(MV_ODB1_VERSION "ANY")
                endif()

            else()
                ecbuild_warn("ODB-1 support is DISABLED - No odbsql script found in ${ODB_PATH}/bin")
            endif()
        else()
            ecbuild_warn("ODB-1 found, but no bin directory in ${ODB_PATH}")
        endif()
    else()
        ecbuild_warn("ODB-1 not found!")
    endif()
endif()


ecbuild_use_package( PROJECT libemos VERSION 4.0.5 REQUIRED )

if(ENABLE_PLOTTING)
    ecbuild_use_package( PROJECT magics VERSION 2.24.4)
    if( MAGICS_FOUND )

        set(MAGICS_LIB_DIR "${magics_BASE_DIR}/lib")

        if(ENABLE_UI AND (NOT MAGICS_HAVE_METVIEW))
            ecbuild_critical("Magics must be built with Metview and Qt support!")
        endif()

        if((NOT ENABLE_UI) AND (NOT MAGICS_HAVE_METVIEW_NO_QT))
            ecbuild_critical("No UI: Magics must be built with Metview but no Qt support!")
        endif()

        if(NOT MAGICS_HAVE_NETCDF)
            ecbuild_critical("Magics must be built with netCDF support!")
        endif()

        if(MAGICS_HAVE_ODB)
            add_definitions(-DMETVIEW_ODB_PLOT)
        else()
            if(ENABLE_ODB)

=== scripts/CMakeLists.txt ===

set(scripts
    dump metview-mail mvrun mvrun_c mvrun_lnx
    logrun metview_stat metview_create_user_dir
    metview_patches
    mvusage metview_help set_mars_env
    document_macros.pl mv_grib_dump
    metview_local.${MV_ENVIRON} metview_local2.${MV_ENVIRON}
    MarsTiggeWrapper
    MarsOdbWrapper
    generate_video
    mv_compress mv_mail mv_uniquename
    mv_odbsql mv_obstat
    mv_mars_catalog.py
    mv_flextra_prep.mv mv_flextra_prep mv_flextra_run
    mv_flexpart_run
    mv_rttov_run
    mv_scm_run mv_scm_vis.mv
    mv_vapor_prep.mv mv_vapor_gui
    select_mars_config
)

if(AT_ECMWF)
    list(APPEND scripts mv_debug_env.sh metgram.py)
endif()



# handle these script files
metview_script_files(SCRIPT_FILES ${scripts})




##############################################################
#
# generate the 'compile' script for inline C/Fortran in Macro


# find the actual path to the emoslib library
get_property(EMOS_LIB_PATH TARGET emos PROPERTY LOCATION)


# for GRIB_API, we *might* get something like
# grib_api;grib_api_f77;grib_api_f90;/usr/lib64/libjasper.so;/usr/lib64/libjpeg.so;/usr/lib64/libm.so
# which is not all that we need to link. So we convert 'grib_api' into '-lgrib_api'
# and for the Fortran libraries.

set(GRIB_API_LIBRARIES_STR " ${GRIB_API_LIBRARIES}") # add a space to the beginning
list(REMOVE_ITEM GRIB_API_LIBRARIES_STR "debug")     # remove non-compiler items from the string
list(REMOVE_ITEM GRIB_API_LIBRARIES_STR "optimized") # remove non-compiler items from the string

string (REPLACE ";"         " "           GRIB_API_LIBRARIES_STR    "${GRIB_API_LIBRARIES_STR}")
if( HAVE_ECCODES )
  string (REPLACE " eccodes"  " -leccodes"  GRIB_API_LIBRARIES_STR  "${GRIB_API_LIBRARIES_STR}")
else()
  string (REPLACE " grib_api" " -lgrib_api" GRIB_API_LIBRARIES_STR  "${GRIB_API_LIBRARIES_STR}")
endif()
string (REPLACE ";"         " "           EMOS_LIBRARIES_STR        "${EMOS_LIB_PATH}")


set(GRIB_API_LIBRARIES_STR "${GRIB_API_LIBRARIES_STR} ${PTHREAD_LIB}") # add pthread in case needed


# we may need to add the netCDF lib dir to the rpath. We don't seem to have a variable
# which tells us this directly, so we need to make an educated guess...
if(DEFINED NETCDF_INCLUDE_DIR)
    set(NETCDF_LIB_RPATH "-Wl,-rpath,${NETCDF_INCLUDE_DIR}/../lib64:${NETCDF_INCLUDE_DIR}/../lib")
    set(GRIB_API_LIBRARIES_STR "${GRIB_API_LIBRARIES_STR} ${NETCDF_LIB_RPATH}")
endif()

set(GRIB_API_LIBRARIES_STR_ORIGINAL "${GRIB_API_LIBRARIES_STR}")       # keep a backup for later


# if we are linking with shared GRIB_API libraries, then in order to be able
# to run compiled inline Fortran/C/Macro programs, we will need to set
# LD_LIBRARY_PATH to where GRIB_API was installed (this should only be
# needed if GRIB_API was installed in a non-default location).
# GRIB_API_LIB_DIR will be added to METVIEW_LD_PATHS and used in compile.in.

# first, if GRIB_API_PATH is not defined, then we need to compute the path
set( grib_handling_pkg grib_api )
if( HAVE_ECCODES )
  set( grib_handling_pkg eccodes )
endif()
if(NOT GRIB_API_PATH)
    get_property(GRIB_LIB_PATH TARGET ${grib_handling_pkg} PROPERTY LIBRARY_OUTPUT_DIRECTORY)
    if(GRIB_LIB_PATH)
        set(GRIB_API_PATH ${GRIB_LIB_PATH}/..)
    else()
        if (grib_api_BASE_DIR)
            set(GRIB_API_PATH ${grib_api_BASE_DIR})
        else()
            if(CMAKE_PREFIX_PATH)
                set(GRIB_API_PATH ${CMAKE_PREFIX_PATH})
            endif()
        endif()
    endif()
    ecbuild_info("Computed GRIB_PATH: ${GRIB_API_PATH}")
endif()


if(GRIB_API_PATH)
    if(EXISTS "${GRIB_API_PATH}/lib")
        set(GRIB_API_LIB_DIR "${GRIB_API_PATH}/lib")
    else()
    endif()

    if(EXISTS "${GRIB_API_PATH}/lib64")
        set(GRIB_API_LIB_DIR "${GRIB_API_PATH}/lib64")
    endif()

    set(GRIB_API_LIBRARIES_STR "-L${GRIB_API_PATH}/lib -L${GRIB_API_PATH}/lib64 -Wl,-rpath,${GRIB_API_PATH}/lib:${GRIB_API_PATH}/lib64 ${GRIB_API_LIBRARIES_STR}")
endif()


foreach (inc ${GRIB_API_INCLUDE_DIRS})
    set(GRIB_API_INCLUDE_DIRS_STR "${GRIB_API_INCLUDE_DIRS_STR} -I${inc}")
endforeach()



list(APPEND METVIEW_INLINE_DEFINITIONS ${GRIB_API_DEFINITIONS})



configure_file(compile.in ${CMAKE_BINARY_DIR}/bin/compile @ONLY)



# in the case of a bundle, the GRIB_API and emoslib locations will have been
# set to their build directories, which is correct when running from 
# the build directory, but not once installed, so we have to change these
# to the location where they will be installed, and create another 'compile'
# script which is the one that will actually be installed. In the case where
# we're not building a bundle, these two compile scripts will be identical.

if(DEFINED METVIEW_BUNDLE OR METVIEW_BUNDLE_TYPE STREQUAL "MMG")
    set(GRIB_API_LIBRARIES_STR    "-L${CMAKE_INSTALL_PREFIX}/lib ${GRIB_API_LIBRARIES_STR_ORIGINAL}")
    set(GRIB_API_INCLUDE_DIRS_STR "-I${CMAKE_INSTALL_PREFIX}/include")
    string(REPLACE "${CMAKE_BINARY_DIR}/lib"  "${CMAKE_INSTALL_PREFIX}/lib"    EMOS_LIBRARIES_STR  "${EMOS_LIBRARIES_STR}")
    set(GRIB_API_PATH ${CMAKE_INSTALL_PREFIX})
endif()

configure_file(compile.in ${CMAKE_BINARY_DIR}/bin/compile_install @ONLY)



install( FILES ${CMAKE_BINARY_DIR}/bin/compile_install  
         DESTINATION ${MV_BIN_DIR}
         RENAME      compile
         PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE)




##################
#
# CONFIG.site

if( DEFINED NETCDF_PATH )
    set(NETCDF_BIN "${NETCDF_PATH}/bin")
else()
    set(NETCDF_BIN "")
endif()

if(DEFINED METVIEW_BUNDLE)
    set(METVIEW_BUNDLE_SRC ${CMAKE_SOURCE_DIR})
endif()

if(DEFINED METVIEW_BUNDLE_MAGICS)
    set(MV_BUNDLE_MAGICS_SRC ${CMAKE_SOURCE_DIR}/magics)
endif()



ecbuild_get_date(TODAYS_DATE)


# # Add certain paths to LD_LIBRARY_PATH.
# # If the given path is not a standard system one, then add it to our list
# # of paths to add to LD_LIBRARY_PATH on Metview's startup. We want to
# # avoid adding system paths here because they can override non-default
# # paths (case in point: the wrong OpenGL library has been known to be
# # picked up - used by VAPOR).
#
# NO - this is not really needed with the rpath, and it can lead, in the
# case of a bundle, to the build directory (Magics) going into the
# LD_LIBRARY_PATH even when installed (no harmful effect seen though).
# 
# set(SYS_LIBDIRS "/usr/lib64" "/usr/lib64/" "/usr/lib" "/usr/lib/" "")
# set(METVIEW_LD_PATHS "")
# 
# foreach(LIBPATH ${MAGICS_LIB_DIR} ${ODB_API_LIB_DIR} ${GRIB_API_LIB_DIR})
#     list(FIND SYS_LIBDIRS ${LIBPATH} IND)
#     if(IND EQUAL -1)  # path not in the list of system paths
#         set(METVIEW_LD_PATHS "${LIBPATH}:${METVIEW_LD_PATHS}")
#     endif()
# endforeach()



# MAGPLUS_HOME - under normal circumstances, we link with a specific
# Magics library which knows where it's been installed, so we don't
# need (or want) to set MAGPLUS_HOME, and in fact we want to avoid
# the situation where a user sets it to the wrong path (as can happen
# if a Magics module is set up by default in a user's environment).
# So the simplest thing is to unset MAGPLUS_HOME and let the library
# find its own resource files. This works fine if Magics has been
# installed, but not if we are linking with a Magics in the build tree.
# In this case MAGPLUS_HOME will need to point to the Magics source(!)
# directory. In Magics 2.27.0 onwards, this is all taken care of by the
# CMake variable MAFPLUS_HOME. If this is not set (i.e. earlier version
# of Magics) then we just unset it. MV_MAGPLUS_HOME_PATH_SET is used
# in metview_base.in.

if(DEFINED MAGPLUS_HOME)
    set(MV_MAGPLUS_HOME_PATH_SET "MAGPLUS_HOME=${MAGPLUS_HOME}")
else()
    set(MV_MAGPLUS_HOME_PATH_SET "unset MAGPLUS_HOME")
endif()



# create the Metview startup script
configure_file(metview_base.in ${FULL_STARTUP_SCRIPT_PATH} @ONLY)


# create a 'production' version of this - just the same, but with
# METVIEW_VERSION=prod instead of dev

set(PROD_TEMPORARY_STARTUP_SCRIPT "${FULL_STARTUP_SCRIPT_PATH}_prod")

add_custom_command( 
    OUTPUT  ${PROD_TEMPORARY_STARTUP_SCRIPT}
    COMMAND sed "s/METVIEW_VERSION=dev/METVIEW_VERSION=prod/g" ${FULL_STARTUP_SCRIPT_PATH} > ${PROD_TEMPORARY_STARTUP_SCRIPT}
    DEPENDS ${FULL_STARTUP_SCRIPT_PATH}
)


ADD_CUSTOM_TARGET(mvs ALL DEPENDS ${FULL_STARTUP_SCRIPT_PATH} ${PROD_TEMPORARY_STARTUP_SCRIPT})


# when we install, we actually want to install the production script and rename it
# NOTE: if building as part of a bundle, then we have the option (EXPOSE_SUBPACKAGES)
# of installing everything apart from the startup script into a subdirectory so that
# libs and executables from other packages don't clash with anything else on
# the system. If we elect to do this (NOT EXPOSE_SUBPACKAGES) then we will have already
# modified the CMAKE_INSTALL_PREFIX (in the bundle's top-level CMakeLists.txt file) to
# put everything two levels deeper. But... we want the startup script to go
# into the original CMAKE_INSTALL_PREFIX/bin directory

if((DEFINED METVIEW_BUNDLE OR DEFINED METVIEW_BUNDLE_TYPE) AND (NOT ENABLE_EXPOSE_SUBPACKAGES))
    set (STARTUP_SCRIPT_INSTALL_DIR "../../bin")
else()
    set (STARTUP_SCRIPT_INSTALL_DIR bin)
endif()
ecbuild_info("Startup script will be installed to: ${STARTUP_SCRIPT_INSTALL_DIR}")


install( FILES       ${PROD_TEMPORARY_STARTUP_SCRIPT}
         RENAME      ${METVIEW_SCRIPT}
         DESTINATION ${STARTUP_SCRIPT_INSTALL_DIR} # NOT ${MV_BIN_DIR}!
         PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE)



## TODO
## If we are building this outside ECMWF, then we want different proxy settings
## (used currently by the OGC clients). We achieve this by simply changing the
## default setting in the ConfigDef file. We can do this with a  a search/replace
## operation. This relies very much on the proxy setting having a uniqe 'signature'
## so that the search/replace can operate on a single line.
#
#if test "x$SITE_NAME" != 'xecmwf'; then
#    configdef=share/metview/etc/ConfigDef
#    configtmp=${configdef}.tmp
#    echo "Not at ECMWF: resetting the default proxy setting in ${configdef}."
#    chmod u+w $configdef
#    sed "s/	} = yes/	} = no/g"  $configdef > $configtmp
#    mv $configtmp $configdef
#fi

#ecbuild_dont_pack(FILES mv_cp metview_local.ecmwf metview_local2.ecmwf)

ecbuild_dont_pack(REGEX "metview_local*.ecm*")
ecbuild_dont_pack(FILES "mv_cp;mv_debug_env.sh;update_MetApps_files.sh")

=== src/Hovmoeller/CMakeLists.txt ===

set(hov_srcs
    Hovmoeller.cc
    HovArea.cc
    HovExpand.cc
    HovHeight.cc
    HovLine.cc
    HovToolkit.cc
    MvHovmFrame.cc
    Factory.h
    Hovmoeller.h
    HovArea.h
    HovExpand.h
    HovHeight.h
    HovLine.h
    HovToolkit.h
    MvHovmFrame.h)


ecbuild_add_executable( TARGET       Hovmoeller
                        SOURCES      ${hov_srcs}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${STANDARD_METVIEW_LIBS}
                    )

metview_module_files(ETC_FILES  ObjectSpec.Hovmoeller
                                MHovmoellerViewDef
                                MHovmoellerViewRules
                                MHovmoellerDataDef
                                HovmoellerViewDef
                                HovmoellerViewRules
                                HovmoellerDataDef
                                HovmoellerDataRules
                      XPM_FILES MHOVMOELLERDATA.xpm
                                MHOVMOELLERVIEW.xpm
                                HOVMOELLERDATA.xpm
                                HOVMOELLERVIEW.xpm)

=== src/libMars/CMakeLists.txt ===

#### NOTE: rpcmars.h rpcmars.c should not be in the distro!!!

# the 'plain' filenames of the MARS source code
set(_libMars_srcs
    tcp.c server.c request.c expand.c
	hash.c memory.c logfile.c options.c
	api.c apibase.c base.c netbase.c nullbase.c gribbase.c nfdbbase.c dhsbase.c odb.cc odbbase.c
	multibase.c archive.c retrieve.c ibmblk.c
	lock.c files.c sh2ll.c guess.c hypercube.c
	check.c environ.c
	handler.c target.c grib.c calc.c field.c
	list.c tools.c hidden.c index.c bufr.c
	externf.c service.c xservice.c
	udp.c queue.c variable.c
	filebase.c account.c cos.c pproc.c restricted.c
	wind.c control.c stream.c
	remove.c authenticate.c flatfilebase.c time.c timer.c json.c
	version.c statistics.c metadata.c ecaccess.c free.c
	schedule.c

    # add the header files because we use this list to help create the tarball later
	api.h base.h bufr.h control.h cos.h ecaccess.h field.h globals.h grib.h hypercube.h
	ibmblk.h index.h json.h lang.h mars.h mcs.h
	netbase.h odb.h proto.h queue.h restricted.h tools.h variable.h 
)


# extra files which will be needed in the tarball
set(extra_files_for_tarball
    ${CMAKE_CURRENT_SOURCE_DIR}/macro_api.c
    ${CMAKE_CURRENT_SOURCE_DIR}/macro_api.h
    ${CMAKE_CURRENT_SOURCE_DIR}/macro_api_internals.h
    ${CMAKE_CURRENT_SOURCE_DIR}/macro_api_f90.f90
    ${CMAKE_CURRENT_SOURCE_DIR}/CMakeLists.txt
    ${MARS_SOURCE}/rpcmars.x
    ${MARS_SOURCE}/langy.y
    ${MARS_SOURCE}/langl.l
    ${MARS_SOURCE}/CMakeLists.txt            # needed for bundle tarball
    ${MARS_SOURCE}/mars_client_version.c.in  # needed for bundle tarball
    ${MARS_SOURCE}/mars_client_version.h.in  # needed for bundle tarball
)    


# add the path to where the source files are located
foreach( file ${_libMars_srcs} )
    list( APPEND libMars_srcs ${MARS_SOURCE}/${file} )
endforeach()


# get the MARS client version number (just invent it for now since we don't use it)

set(MARS_CLIENT_MAJOR_VERSION 0)
set(MARS_CLIENT_MINOR_VERSION 0)
set(MARS_CLIENT_PATCH_VERSION 0)
configure_file( ${MARS_SOURCE}/mars_client_version.h.in  mars_client_version.h )
configure_file( ${MARS_SOURCE}/mars_client_version.c.in  mars_client_version.c )



# copy all the MARS source files to a subdirectory of the build directory; this is
# so that we have a clean version of the MARS client source code in its own directory
# which can be packaged into the export tarball.
# NO - see code at the end of this file for the real solution
#foreach( file ${libMars_srcs} )
#    get_filename_component( basefile ${file} NAME )
#    configure_file(${file} "${CMAKE_BINARY_DIR}/src/libMarsClient/${basefile}" COPYONLY) # copy to binary dir
#endforeach()

# add the local and generated files - they are not in the MARS source directory
list( APPEND libMars_srcs ${CMAKE_CURRENT_BINARY_DIR}/langy.c ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.c ${CMAKE_CURRENT_SOURCE_DIR}/macro_api.c)


if ( NOT FDB_FOUND )
    add_definitions(-DNOFDB)
endif()

if ( ODB_API_FOUND )
    add_definitions(-DODB_SUPPORT)
else()
    add_definitions(-DNOODB)
endif()

if ( NOT LIBEMOS_FOUND )
    add_definitions(-DNOPPROC)
    ecbuild_critical("No emoslib found - should not have got this far!")
endif()


find_package(CMath)



# rpcgen, when creating the .c file, has an include for the header file;
# unfortunately, it does not know where the header file has been generated, so it
# assumes it will be in the source directory. This is wrong, it should be the
# binary directory. Therefore, we first copy the .x file to the binary directory
# and work on it there. Note: will this cause a problem with in-source builds?
# If so, we may need to first check whether the file already exists.

if(NOT CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_CURRENT_BINARY_DIR)
    configure_file(${MARS_SOURCE}/rpcmars.x ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.x)
endif()

ADD_CUSTOM_COMMAND(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.h
	COMMAND rpcgen -h -o ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.h ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.x
    DEPENDS ${MARS_SOURCE}/rpcmars.x)

ADD_CUSTOM_COMMAND(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.c
	COMMAND rpcgen -c -o ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.c ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.x
    DEPENDS ${MARS_SOURCE}/rpcmars.x)

ADD_CUSTOM_COMMAND(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/langl.c
	COMMAND lex -l ${MARS_SOURCE}/langl.l\; sed -e s/yy/yy_mars/g < lex.yy.c > ${CMAKE_CURRENT_BINARY_DIR}/langl.c
    DEPENDS ${MARS_SOURCE}/langl.l)

ADD_CUSTOM_COMMAND(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/langy.c
	COMMAND yacc -t ${MARS_SOURCE}/langy.y\; sed -e s/yy/yy_mars/g < y.tab.c > ${CMAKE_CURRENT_BINARY_DIR}/langy.c
    DEPENDS ${MARS_SOURCE}/langy.y)

ADD_CUSTOM_TARGET(mvmarsxdr DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.h ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.c)
ADD_CUSTOM_TARGET(mvmarslex DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/langy.c   ${CMAKE_CURRENT_BINARY_DIR}/langl.c)

###set( libMars_srcs ${libMars_srcs} PARENT_SCOPE )

include_directories(BEFORE   ${CMAKE_CURRENT_BINARY_DIR} ${METVIEW_STANDARD_INCLUDES} ${METVIEW_ODB_API_INCLUDE_DIRS})

ecbuild_add_library( TARGET      MvMars
                     TYPE        STATIC
                     GENERATED   mars_client_version.c
                     SOURCES     ${libMars_srcs} mars_client_version.c
                     TEMPLATES   ${common_templates}
                     DEFINITIONS ${METVIEW_EXTRA_DEFINITIONS}
                     LIBS        ${METVIEW_EXTRA_LIBRARIES}  ${METVIEW_ODB_API_LIBRARIES} ${CURL_LIBRARIES}
                    )

ADD_DEPENDENCIES(MvMars mvmarsxdr mvmarslex)


ecbuild_add_library( TARGET      macro_api_f90
                     TYPE        STATIC
                     SOURCES     macro_api_f90.f90
                     TEMPLATES   ${common_templates}
                     DEFINITIONS ${METVIEW_EXTRA_DEFINITIONS}
                     LIBS        ${METVIEW_EXTRA_LIBRARIES}
                    )


configure_file(macro_api.h ${CMAKE_BINARY_DIR}/include/macro_api.h COPYONLY)

install( FILES ${CMAKE_BINARY_DIR}/include/macro_api.h
         DESTINATION include
         PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ)




if(NOT DEFINED METVIEW_BUNDLE)

    # for the tarball, we want to include the MARS client source, but only the files that we actually
    # use in Metview. So we create a list of all files in the source, then subtract from it the list
    # of source files defined previously as libMars_srcs.

    # first, list all the files in the MARS source directory - these are the files we will NOT pack
    file(GLOB mars_unwanted_src_files   "${MARS_SOURCE}/*")
    file(GLOB mars_unwanted_tools_files "${MARS_SOURCE}/tools/*")
    list(APPEND mars_unwanted_src_files ${mars_unwanted_tools_files})

    # remove each wanted source file from the list
    foreach( file ${libMars_srcs} ${extra_files_for_tarball})
        list(REMOVE_ITEM mars_unwanted_src_files ${file})
    endforeach()

    # these filenames will be treated as regular expressions, so we need to be more
    # explicit and put a dollar sign at the end so that they don't match with too much
    set(mars_real_unwanted_src_files "")
    foreach( file ${mars_unwanted_src_files} )
        list(APPEND mars_real_unwanted_src_files "${file}\$")
    endforeach()

    # add our revised list to ECBUILD_DONT_PACK_FILES
    # - we don't use ecbuild_dont_pack() because it makes everything relative to the
    #   source directory
    list( APPEND ECBUILD_DONT_PACK_FILES ${mars_real_unwanted_src_files})
    set( ECBUILD_DONT_PACK_FILES ${ECBUILD_DONT_PACK_FILES} CACHE INTERNAL "" )

endif()


# soon to be redundant - remove unwanted files from libMars/MARS
# list of files (regular expressions) to exclude from the source tarball
# note "MARS/m$" - the dollar is required because otherwise CPACK will exclude any
# file beginning with an 'm'!
ecbuild_dont_pack(REGEX "MARS/config*")
ecbuild_dont_pack(REGEX "MARS/make*")
ecbuild_dont_pack(FILES "MARS/mars.test;MARS/m$;MARS/gnumake_target;MARS/Makefile;MARS/account_check.c")
ecbuild_dont_pack(FILES "MARS/blk.c;MARS/certify.c;MARS/cpli.h;MARS/cvers.h;MARS/dce.c;MARS/dce.h;MARS/dcebase.c;MARS/dceclient.c")
ecbuild_dont_pack(FILES "MARS/dceremote.c;MARS/dceserver.c;MARS/eccert.c;MARS/eccert.h;MARS/ecopt.h;MARS/emoscycle.c;MARS/extargs.c;")
ecbuild_dont_pack(FILES "MARS/feedtask.c;MARS/gpl-3.0.txt;MARS/grib_api_release.c;MARS/htest.c;MARS/lckfile.c")
ecbuild_dont_pack(FILES "MARS/licence_header;MARS/mars.c;MARS/marsdce.c;MARS/marsdce.h;MARS/marsfdb.c;MARS/marsmon.c;MARS/marsversion.c")
ecbuild_dont_pack(FILES "MARS/mcs.c;MARS/mrpc.x;MARS/msbase.c;MARS/multidef.c;MARS/multidef.h;MARS/ocean.c")
ecbuild_dont_pack(FILES "MARS/rdb.c;MARS/reqmerge.c;MARS/source.c;MARS/source.h;MARS/test.c;MARS/testh.c;MARS/teststats.c")

=== src/libMarsClient/CMakeLists.txt ===
### config headers

configure_file( mars_client_version.h.in  mars_client_version.h )
configure_file( mars_client_version.c.in  mars_client_version.c )

# compile definitions

add_definitions( -DR64 )

if( ECMWF )
    add_definitions( -DECMWF )
endif()

# ecbuild automatically test endiness and sets variable EC_BIG_ENDIAN or EC_LITTLE_ENDIAN
if( EC_BIG_ENDIAN )
	message( STATUS "System is big endian" )
else()
	message( STATUS "System is little endian" )
	add_definitions(-DLITTLE_END)
endif()

if( NOT HAVE_FDB )
	add_definitions(-DNOFDB)
endif()

if( NOT HAVE_ODB )
	add_definitions(-DNOODB)
else()
	add_definitions(-DODB_SUPPORT )
	include_directories( ${ODB_API_INCLUDE_DIRS} ${ECKIT_INCLUDE_DIRS} )
endif()

if( NOT HAVE_PPROC )
	add_definitions(-DNOPPROC)
endif()

if( NOT CURL_FOUND )
	add_definitions(-DNOCURL)
endif()

# sources

list( APPEND mars_client_src_files
account.c
archive.c
authenticate.c
base.c
bufr.c
calc.c
certify.c
check.c
control.c
cos.c
ecaccess.c
eccert.c
environ.c
expand.c
extargs.c
externf.c
feedtask.c
field.c
filebase.c
files.c
flatfilebase.c
free.c
gribbase.c
grib.c
guess.c
handler.c
hash.c
hidden.c
hypercube.c
ibmblk.c
index.c
langy.c
list.c
lock.c
logfile.c
marsxdr.c
mcs.c
memory.c
dhsbase.c
metadata.c
msbase.c
multibase.c
netbase.c
nfdbbase.c
nullbase.c
odbbase.c
options.c
pproc.c
queue.c
rdb.c
remove.c
request.c
restricted.c
retrieve.c
schedule.c
server.c
service.c
sh2ll.c
statistics.c
stream.c
target.c
tcp.c
time.c
timer.c
tools.c
udp.c
variable.c
version.c
json.c
odb.cc
api.c
apibase.c
wind.c)

# targets

configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/rpcmars.x ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.x COPYONLY )

add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.h
	COMMAND ${CMAKE_COMMAND} -E remove ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.h
	COMMAND rpcgen -h -o ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.h ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.x
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.x )

add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/marsxdr.c
	COMMAND ${CMAKE_COMMAND} -E remove ${CMAKE_CURRENT_BINARY_DIR}/marsxdr.c
	COMMAND rpcgen -c -o ${CMAKE_CURRENT_BINARY_DIR}/marsxdr.c ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.x
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.x )

add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/langl.c
	COMMAND lex -l ${CMAKE_CURRENT_SOURCE_DIR}/langl.l\; sed -e s/yy/yy_mars/g < lex.yy.c > ${CMAKE_CURRENT_BINARY_DIR}/langl.c
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/langl.l)

add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/langy.c
	COMMAND yacc -t ${CMAKE_CURRENT_SOURCE_DIR}/langy.y\; sed -e s/yy/yy_mars/g < y.tab.c > ${CMAKE_CURRENT_BINARY_DIR}/langy.c
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/langy.y)

add_custom_target(marsxdr DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.h ${CMAKE_CURRENT_BINARY_DIR}/marsxdr.c)
add_custom_target(marslex DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/langy.c ${CMAKE_CURRENT_BINARY_DIR}/langl.c)

#### TODO: Mechanism to choose ecCodes over grib_api -- REVIEW
set( grib_handling_pkg grib_api )
if( HAVE_ECCODES )
    set( grib_handling_pkg eccodes )
endif()
####

ecbuild_add_library(
	TARGET      mars
    TYPE        STATIC
    GENERATED   mars_client_version.c
	SOURCES     ${mars_client_src_files} mars_client_version.c
	DEPENDS     marsxdr marslex
    PRIVATE_INCLUDES
        ${GRIB_API_INCLUDE_DIRS}
        ${CURL_INCLUDE_DIRS}
    DEFINITIONS ${GRIB_API_DEFINITIONS}
    LIBS        ${grib_handling_pkg} ${MARS_FEATURE_LIBRARIES} ${CURL_LIBRARIES} ${CMATH_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} )

set_directory_properties( ADDITIONAL_MAKE_CLEAN_FILES rpcmars.h marsxdr.c langl.c langy.c )

ecbuild_add_executable(
	TARGET    mars.bin
  INCLUDES  ${GRIB_API_INCLUDE_DIRS}
	SOURCES		mars.c
  LIBS		  mars
)

add_subdirectory( tools )

=== test/macros/CMakeLists.txt ===

# ------------------------------------------------------------------------
# MACRO metview_etc_files
# Ensures the files listed in ETC_FILES are copied to the build directory
# and that they will be installed at install time
# ------------------------------------------------------------------------

macro(metview_macro_test)
    set(options)
    set(single_value_args MACRO)
    set(multi_value_args RESOURCES)
    cmake_parse_arguments( _PAR "${options}" "${single_value_args}" "${multi_value_args}" ${_FIRST_ARG} ${ARGN} )

    ecbuild_add_test(TARGET      ${_PAR_MACRO}_dummy_target
                     COMMAND     ${FULL_STARTUP_SCRIPT_PATH}
                     TYPE        SCRIPT
                     ARGS        -b ${_PAR_MACRO}
                     RESOURCES   ${_PAR_MACRO} ${_PAR_RESOURCES})

    set(all_tests "${all_tests}${_PAR_MACRO} ") # note the spacing
endmacro()



set(all_tests) # empty to start with



if(ENABLE_PLOTTING)
    metview_macro_test(MACRO     HelloWorld.mv
                       RESOURCES set_output.mv ../data/z500.grb)

    metview_macro_test(MACRO     layoutx3.mv
                       RESOURCES set_output.mv ../data/z500.grb)
endif()


metview_macro_test(MACRO     grib_dates.mv
                   RESOURCES  ../data/fc_data.grib
                              ../data/hindcast.grib)

metview_macro_test(MACRO     grib_nearest_gridpoint.mv
                   RESOURCES  ../data/t1000_LL_1x1.grb
                              ../data/t1000_LL_1x1_subarea.grb
                              ../data/t1000_LL_2x2.grb)

metview_macro_test(MACRO     interpolation_sh_to_ll.mv
                   RESOURCES  ../data/t1000_SH.grb)

metview_macro_test(MACRO     interpolation_sh_to_rgg.mv
                   RESOURCES  ../data/t1000_SH.grb)

metview_macro_test(MACRO     interpolation_rgg_to_ll.mv
                   RESOURCES  ../data/t1000_SH_to_RGG_reference.grb)

metview_macro_test(MACRO     grib_to_gpt.mv
                   RESOURCES  ../data/t1000_LL_2x2.grb)

metview_macro_test(MACRO     gpt_to_grib_core.mv
                   RESOURCES  ../data/bufr_obs_filter_reference.gpt
                              ../data/gpt_to_grib_reciprocal_reference.grb
                              ../data/gpt_to_grib_exp_mean_reference.grb
                              ../data/gpt_to_grib_exp_sum_reference.grb)

metview_macro_test(MACRO     gpt_to_grib_with_template.mv
                   RESOURCES  ../data/t1000_LL_2x2.grb ../data/10U_GG.grb)

metview_macro_test(MACRO     gpt_to_grib_nearest.mv
                   RESOURCES  ../data/t1000_LL_7x7.grb
                              ../data/example_XYLDTZ.geo
                              ../data/gpt_to_grib_nearest_sum_reference.grb
                              ../data/gpt_to_grib_nearest_mean_reference.grb
                              ../data/gpt_to_grib_nearest_count_reference.grb)

#metview_macro_test(MACRO     interpolation_gg_to_subarea.mv
#                   RESOURCES  ../data/10U_GG.grb)

metview_macro_test(MACRO     bufr_obs_filter.mv
                   RESOURCES  ../data/bufr-1.bufr ../data/bufr_obs_filter_reference.gpt)

metview_macro_test(MACRO     bufr_picker.mv
                   RESOURCES  ../data/bufr-2.bufr ../data/bufr_picker_reference.gpt)

metview_macro_test(MACRO     inline_c.mv
                   RESOURCES ../data/z500.grb)

metview_macro_test(MACRO     inline_fortran.mv
                   RESOURCES ../data/z500.grb)

metview_macro_test(MACRO     station.mv)

metview_macro_test(MACRO     vectors.mv)

metview_macro_test(MACRO     lists.mv)

metview_macro_test(MACRO     fieldsets.mv)

if(ENABLE_MARS)
    metview_macro_test(MACRO      MarsAccess.mv
                       RESOURCES  ../data/10U_GG.grb )
endif()


if(METVIEW_ODB)
    metview_macro_test(MACRO      odb_read.mv
                       RESOURCES  ../data/odb_test_set.odb )
endif()

# generate a script which can be used to run the tests on the installed version
set(METVIEW_COMMAND "${CMAKE_INSTALL_PREFIX}/bin/${METVIEW_SCRIPT}")
set(TESTS_DIR       "${CMAKE_CURRENT_BINARY_DIR}")
configure_file(post_install_tests.sh.in ${CMAKE_CURRENT_BINARY_DIR}/metview_post_install_tests.sh @ONLY)

install( FILES ${CMAKE_CURRENT_BINARY_DIR}/metview_post_install_tests.sh 
         DESTINATION ${MV_BIN_DIR}
         PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE)

=== debian/changelog ===
metview (4.8.0-4) unstable; urgency=medium

  * Add metview.desktop and icon.

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 23 Dec 2016 13:24:36 +0000

metview (4.8.0-3) unstable; urgency=medium

  * Mark metview-data as Multi-Arch: foreign
  * Remove unnecessary GRIB_API_PATH from rule

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 09 Dec 2016 09:44:05 +0000

metview (4.8.0-2) unstable; urgency=medium

  * Build-Depend on libemos-bin, libopenjp2-7-dev. Closes: #846775

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 03 Dec 2016 13:10:48 +0000

metview (4.8.0-1) unstable; urgency=medium

  * New upstream release
  * Now build against eccodes instead of grib-api

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 30 Nov 2016 16:43:48 +0000

metview (4.7.2-3) unstable; urgency=medium

  * Depend on mksh, ksh subst. needed to build. Closes: #843025.

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 21 Nov 2016 07:39:18 +0000

metview (4.7.2-2) unstable; urgency=medium

  * Drop dependencies on ksh: no ksh scripts now included. Closes: #843025.

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 03 Nov 2016 11:22:47 +0000

metview (4.5.7-4) unstable; urgency=medium

  * Add FPIC support properly. FPIC not being picked up on CXX for i386

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 09 Nov 2015 10:37:35 +0000

=== debian/control ===
Source: metview
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper (>= 10), 
  flex, bison, libhdf5-dev, libpango1.0-dev, chrpath, mksh,
  libqt5webkit5-dev, qtbase5-dev, libqt5xmlpatterns5-dev,
  libeccodes-dev | libgrib-api-dev, 
  libeccodes-tools | libgrib-api-tools,
  libemos-dev (>= 2:4.1.1-2),  libemos-bin,
  libboost-dev, libopenjp2-7-dev,
  libmagics++-metview-dev, 
  libmagics++-dev (>= 2.28.0-2),
  libxmu-dev, libgdbm-dev, libcurl4-gnutls-dev,
  libcairo2-dev, pkg-config, swig, libexpat1-dev,
  libterralib-dev (>= 4.3.0+dfsg.2-8), 
  libproj-dev, libqt5svg5-dev,
  libgd-dev, imagemagick, libnetcdf-dev, libnetcdf-cxx-legacy-dev,
  cmake, flextra, gfortran, libgeotiff-dev,
  python3-all-dev
Standards-Version: 3.9.8
Homepage: https://software.ecmwf.int/wiki/display/METV/Metview
Vcs-Git: git://anonscm.debian.org/debian-science/packages/metview.git

Package: metview
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
 x11-utils, metview-data, python
Recommends: magics++
Description: Interactive data visualization and analysis environment,
 Metview has been designed as a flexible, modular and extendible system 
 able to accommodate the evolving needs of the user. 
 The system is based on the ECMWF standards for graphics (Magics) and 
 data access (MARS) but can also access locally stored data. 
 The user interface is based on Motif and Qt. Metview is a 
 fully distributed system where modules can run on different workstations
 and servers.
 .
 Metview is a cooperative project between ECMWF and INPE/CPTEC, Brazil. 
 ECMWF has also been assisted by a staff member of Météo-France. 

Package: metview-data
Depends: ${misc:Depends}
Architecture: all
Multi-Arch: foreign
Description: Data needed for the Metview data analysis environment
 Metview has been designed as a flexible, modular and extendible system
 able to accommodate the evolving needs of the user.
 The system is based on the ECMWF standards for graphics (Magics) and
 data access (MARS) but can also access locally stored data.
 The user interface is based on Motif and Qt. Metview is a
 fully distributed system where modules can run on different workstations
 and servers.
 .
 This package provides data files needed for metvieww.

Package: libmetview-dev
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}
Section: libdevel
Description: Development files for MetView
 Metview has been designed as a flexible, modular and extendible system
 able to accommodate the evolving needs of the user.
 The system is based on the ECMWF standards for graphics (Magics) and
 data access (MARS) but can also access locally stored data.
 The user interface is based on Motif and Qt. Metview is a
 fully distributed system where modules can run on different workstations
 and servers.
 .
 This package provides static libraries and include files for building
 Metview-based software.

=== debian/watch ===
version=3
# https://software.ecmwf.int/wiki/display/METV/Releases Metview\-(.+)\-Source\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))\?api=v(.+)
https://software.ecmwf.int/wiki/display/METV/Releases /wiki/download/attachments/.*/Metview\-(.+)\-Source.tar.gz?api=v2
